#include <LiquidCrystal.h>

#define nB0 31
#define nC1 33
#define nCS1 35
#define nD1 37
#define nDS1 39
#define nE1 41
#define nF1 44
#define nFS1 46
#define nG1 49
#define nGS1 52
#define nA1 55
#define nAS1 58
#define nB1 62
#define nC2 65
#define nCS2 69
#define nD2 73
#define nDS2 78
#define nE2 82
#define nF2 87
#define nFS2 93
#define nG2 98
#define nGS2 104
#define nA2 110
#define nAS2 117
#define nB2 123
#define nC3 131
#define nCS3 139
#define nD3 147
#define nDS3 156
#define nE3 165
#define nF3 175
#define nFS3 185
#define nG3 196
#define nGS3 208
#define nA3 220
#define nAS3 233
#define nB3 247
#define nC4 262
#define nCS4 277
#define nD4 294
#define nDS4 311
#define nE4 330
#define nF4 349
#define nFS4 370
#define nG4 392
#define nGS4 415
#define nA4 440
#define nAS4 466
#define nB4 494
#define nC5 523
#define nCS5 554
#define nD5 587
#define nDS5 622
#define nE5 659
#define nF5 698
#define nFS5 740
#define nG5 784
#define nGS5 831
#define nA5 880
#define nAS5 932
#define nB5 988
#define nC6 1047
#define nCS6 1109
#define nD6 1175
#define nDS6 1245
#define nE6 1319
#define nF6 1397
#define nFS6 1480
#define nG6 1568
#define nGS6 1661
#define nA6 1760
#define nAS6 1865
#define nB6 1976
#define nC7 2093
#define nCS7 2217
#define nD7 2349
#define nDS7 2489
#define nE7 2637
#define nF7 2794
#define nFS7 2960
#define nG7 3136
#define nGS7 3322
#define nA7 3520
#define nAS7 3729
#define nB7 3951
#define nC8 4186
#define nCS8 4435
#define nD8 4699
#define nDS8 4978
#define REST 0

// viteza melodiei
int speed = 95;

int buzzer = 5; // pin
int button = 14;

bool temp = false;

LiquidCrystal lcd(6, 7, 8, 9, 10, 11);

const int pPin = 13; // pinul pt ping
const int ePin = 12; // pinul pt ecou

int red = 2;
int green = 4;
int blue = 3;

/*
notele definite la inceputul codului urmate de durata de tipul sfert optime
saisprezecime
//se adauga o optsprezecime la duratele cu -
*/

int got_soundtrack[] = {

    nG4,
    8,
    nC4,
    8,
    nDS4,
    16,
    nF4,
    16,
    nG4,
    8,
    nC4,
    8,
    nDS4,
    16,
    nF4,
    16, // 1
    nG4,
    8,
    nC4,
    8,
    nDS4,
    16,
    nF4,
    16,
    nG4,
    8,
    nC4,
    8,
    nDS4,
    16,
    nF4,
    16,
    nG4,
    8,
    nC4,
    8,
    nE4,
    16,
    nF4,
    16,
    nG4,
    8,
    nC4,
    8,
    nE4,
    16,
    nF4,
    16,
    nG4,
    8,
    nC4,
    8,
    nE4,
    16,
    nF4,
    16,
    nG4,
    8,
    nC4,
    8,
    nE4,
    16,
    nF4,
    16,
    nG4,
    -4,
    nC4,
    -4, // 5
    nDS4,
    16,
    nF4,
    16,
    nG4,
    4,
    nC4,
    4,
    nDS4,
    16,
    nF4,
    16, // 6
    nD4,
    -1, // 7&8
    nF4,
    -4,
    nAS3,
    -4,
    nDS4,
    16,
    nD4,
    16,
    nF4,
    4,
    nAS3,
    -4,
    nDS4,
    16,
    nD4,
    16,
    nC4,
    -1,//11&12
    // repeta
    nG4,
    -4,
    nC4,
    -4,//5
    nDS4,
    16,
    nF4,
    16,
    nG4,
    4,
    nC4,
    4,
    nDS4,
    16,
    nF4,
    16,//6
    nD4,
    -1,//7&8
    nF4,
    -4,
    nAS3,
    -4,
    nDS4,
    16,
    nD4,
    16,
    nF4,
    4,
    nAS3,
    -4,
    nDS4,
    16,
    nD4,
    16,
    nC4,
    -1,//11&12
    nG4,
    -4,
    nC4,
    -4,
    nDS4,
    16,
    nF4,
    16,
    nG4,
    4,
    nC4,
    4,
    nDS4,
    16,
    nF4,
    16,
    nD4,
    -2,//15
    nF4,
    -4,
    nAS3,
    -4,
    nD4,
    -8,
    nDS4,
    -8,
    nD4,
    -8,
    nAS3,
    -8,
    nC4,
    -1,
    nC5,
    -2,
    nAS4,
    -2,
    nC4,
    -2,
    nG4,
    -2,
    nDS4,
    -2,
    nDS4,
    -4,
    nF4,
    -4,
    nG4,
    -1,
    nC5,
    -2,//28
    nAS4,
    -2,
    nC4,
    -2,
    nG4,
    -2,
    nDS4,
    -2,
    nDS4,
    -4,
    nD4,
    -4,
    nC5,
    8,
    nG4,
    8,
    nGS4,
    16,
    nAS4,
    16,
    nC5,
    8,
    nG4,
    8,
    nGS4,
    16,
    nAS4,
    16,
    nC5,
    8,
    nG4,
    8,
    nGS4,
    16,
    nAS4,
    16,
    nC5,
    8,
    nG4,
    8,
    nGS4,
    16,
    nAS4,
    16,
    REST,
    4,
    nGS5,
    16,
    nAS5,
    16,
    nC6,
    8,
    nG5,
    8,
    nGS5,
    16,
    nAS5,
    16,
    nC6,
    8,
    nG5,
    16,
    nGS5,
    16,
    nAS5,
    16,
    nC6,
    8,
    nG5,
    8,
    nGS5,
    16,
    nAS5,
    16,
};

/*pentru fiecare nota vor fi 4 bytes*/

int notes = sizeof(got_soundtrack) / sizeof(got_soundtrack[0]) / 2;

long noteTimesBytes = 60000 * 4;
//durata unei note in milisecunde
int entireNote = (noteTimesBytes) / speed;

int noteDelimiter = 0, NOTE_LENGTH = 0;

void GameOfThrones()
{
  
    int currentNote = 0;

        while(currentNote < notes * 2){//vectorul e de 2 ori mai mare decat numarul de note

    //durata unei note
    noteDelimiter = got_soundtrack[currentNote + 1];

    if (noteDelimiter > 0) {

      //nota normala
      NOTE_LENGTH = (entireNote) / noteDelimiter;
            
    } else if (noteDelimiter < 0) {

      //note negative + 18th
      NOTE_LENGTH = (entireNote) / abs(noteDelimiter);
      NOTE_LENGTH *= 1.5; //se mareste cu inca jumate durata notelor negartive
    }

    //1 - 0.9 => 10 % pauza in note
    tone(buzzer, got_soundtrack[currentNote], NOTE_LENGTH * 0.9);

    //un delay intre note
    delay(NOTE_LENGTH);

    //pauza inainte de urmatoare nota
    noTone(buzzer);

        currentNote += 2;
  }
}

void setup()
{
  Serial.begin(9600);

  lcd.begin(16, 2);
    pinMode(12, INPUT);
  lcd.clear();
  pinMode(blue, OUTPUT);
  pinMode(buzzer, OUTPUT);
    pinMode(red, OUTPUT);
  pinMode(green, OUTPUT);
  pinMode(13, OUTPUT);
  pinMode(button, INPUT_PULLUP);
}

void loop()
{
  float note_length, centimiters;
  pinMode(pPin, OUTPUT);
  digitalWrite(pPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(pPin, LOW);
  pinMode(ePin, INPUT);
  note_length = pulseIn(ePin, HIGH);
  centimiters = note_length * 0.034 / 2;
  Serial.print(centimiters);
  Serial.print("cm");
  Serial.println();
  delay(100);

  if (digitalRead(button) == LOW) {
    temp = !temp;
    delay(500);
  }

  if (centimiters <= 10) {
    lcd.setCursor(0, 0);
    lcd.print("For the watch   ");
    lcd.setCursor(0, 1);
    lcd.print(centimiters);
    lcd.print("cm               ");
    multiColor(1, 0, 0); // albastru
    if (temp == true) {
      GameOfThrones();
    }

    if (temp == false) {
      noTone(buzzer);
    }
    delay(100);
  } else if (centimiters > 10 && centimiters <= 100) {
    lcd.setCursor(0, 0);
    lcd.print("Almost there    ");
    lcd.setCursor(0, 1);
    lcd.print(centimiters);
    lcd.print("cm               ");
    multiColor(1, 0, 0);//rosu
    delay(100);

  } else if (centimiters > 100) {
    lcd.setCursor(0, 0);
    lcd.print("Winter is coming");
    lcd.setCursor(0, 1);
    lcd.print("================");
    multiColor(0, 1, 0); // verde
    digitalWrite(buzzer, LOW);
  }
}
void multiColor(int red_val, int green_val, int blue_val)//functie RGB
{
  digitalWrite(red, red_val);
  digitalWrite(green, green_val);
  digitalWrite(blue, blue_val);
}
